<template>

    <div class="container align-middle p-0 d-flex flex-column text-center">
        <header>
            <img src="../../assets/icon-left-font-monochrome-white.png" alt="Logo Groupomania">
            <h1 class="text-light">Inscription</h1>
        </header>
        <div class="form-group">
            <label for="mail" class="mb-0 mt-2 text-light">Adresse Mail</label>
            <input class="form-control" v-model="form.email" type="email" id="mail" required>
        </div>
        <p class="mt-0 mb-0 text-warning text-center">{{warning.email}}</p>
        <div class="form-group">
                <label for="password" class="mb-0 mt-2 text-light">Mot de passe</label>
                <div class="input-group">
                    <input v-model="form.password" id="password" :type="passwordType.text" class="form-control password">
                    <div class="input-group-append">
                        <button class="btn btn-password" type="button" @click="() => showPassword = !showPassword" aria-label="Afficher le mot de passe">
                            <i v-bind:class="passwordType.icon"></i>
                        </button>
                    </div>
                </div>

        </div>
        <p class="mt-0 mb-0 text-warning text-center">{{warning.password}}</p>
        <div class="form-group">
            <label for="confirm-password" class="mb-0 mt-2 text-light">Confirmer le mot de passe</label>
            <div class="input-group">
                <input v-model="form.confirmPassword" :type="confirmPasswordType.text" class="form-control password" id="confirm-password">
            </div>
        </div>
        <p class="mt-0 mb-0 text-warning text-center">{{warning.confirmPassword}}</p>
        <div class="form-group">
            <label for="firstname" class="mb-0 mt-2 text-light">Prénom</label>
            <input class="form-control " v-model="form.firstname" type="text" id="firstname">
        </div>
        <p class="mt-0 mb-0 text-warning text-center">{{warning.firstname}}</p>
        <div class="form-group">
            <label for="lastname" class="mb-0 mt-2 text-light">Nom</label>
            <input class="form-control" v-model="form.lastname" type="text" id="lastname">
        </div>
        <p class="mt-0 mb-0 text-warning text-center">{{warning.lastname}}</p>
        <div class="mt-3 d-flex justify-content-around">
            <button v-on:click="inscription()" class="btn btn-inscription text-light">Inscription</button>
        </div>
        <p class="text-light mt-5 mb-0 little-font">Vous possédez déjà un compte?</p>
        <router-link to="/connexion"><button class="btn btn-connexion text-light little-font">Connectez-vous!</button></router-link>
    </div>
</template>

<script>

export default{
    data(){
        return{
            name: 'Inscription',
                form: {
                    email: '',
                    password: '',
                    confirmPassword:'',
                    firstname:'',
                    lastname:''
                },
                warning:{
                    email: '',
                    password: '',
                    confirmPassword:'',
                    firstname:'',
                    lastname:''
                },
                showPassword: false,
                inscriptionOk:false
        }
    },
    computed: {
        passwordType() {
            const passType = {
                text: "password",
                icon: "fas fa-eye"
            }
            
            if (this.showPassword) {
                passType.text = "text"
                passType.icon = "fas fa-eye-slash"
            }
            
            return passType
        },
        confirmPasswordType() {
            const confirmPassType = {
                text: "password",
                icon: "fas fa-eye"
            }
            if (this.showConfirmPassword) {
                confirmPassType.text = "text"
                confirmPassType.icon = "fas fa-eye-slash"
            }
            return confirmPassType
        }
    },
    methods:{
        inscription: function(){
            const url = 'http://localhost:3000/api/users/signup'
            const axios = require('axios')
                if (this.form.email == ''||this.form.password == ''||this.form.confirmPassword == ''||this.form.firstname == ''||this.form.lastname == '') {
                    this.warning.email = 'Adresse e-mail obligatoire!'
                    this.warning.password = 'Mot de passe obligatoire!'
                    this.warning.confirmPassword = 'Confirmation de mot de passe obligatoire!'
                    this.warning.firstname = 'Prénom obligatoire!'
                    this.warning.lastname = 'Nom obligatoire!'
                }else{
                    axios.post(url,this.form)
                    .then(function(res){
                        if (res.status ==200) {
                            window.location.href = 'connexion'
                        }
                        }
                    )
                    .catch(err=>{
                        if(err.message.indexOf(401)!== -1){
                            this.warning.lastname = 'Votre compte existe déjà! Connectez-vous!'
                        }
                    })
                }
            
        }
    }
}

</script>

<style src="../Connexion/Connexion.css">

</style>